Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.security.cert
Class CertificateFactory

    java.lang.Object
      |
      +--java.security.cert.CertificateFactory

public class CertificateFactory
extends Object

This class defines the functionality of a certificate factory, which is used to generate certificate, certification path (`CertPath`) and certificate revocation list (CRL) objects from their encodings.

For encodings consisting of multiple certificates, use `generateCertificates` when you want to parse a collection of possibly unrelated certificates. Otherwise, use `generateCertPath` when you want to generate a `CertPath` (a certificate chain) and subsequently validate it with a `CertPathValidator`.

A certificate factory for X.509 must return certificates that are an instance of `java.security.cert.X509Certificate`, and CRLs that are an instance of `java.security.cert.X509CRL`.

The following example reads a file with Base64 encoded certificates, which are each bounded at the beginning by -----BEGIN CERTIFICATE-----, and bounded at the end by -----END CERTIFICATE-----. We convert the `FileInputStream` (which does not support `mark` and `reset`) to a `BufferedInputStream` (which supports those methods), so that each call to `generateCertificate` consumes only one certificate, and the read position of the input stream is positioned to the next certificate in the file:

     FileInputStream fis = new FileInputStream(filename);
     BufferedInputStream bis = new BufferedInputStream(fis);

     CertificateFactory cf = CertificateFactory.getInstance("X.509");

     while (bis.available() > 0) {
        Certificate cert = cf.generateCertificate(bis);
        System.out.println(cert.toString());
     }

The following example parses a PKCS#7-formatted certificate reply stored in a file and extracts all the certificates from it:

     FileInputStream fis = new FileInputStream(filename);
     CertificateFactory cf = CertificateFactory.getInstance("X.509");
     Collection c = cf.generateCertificates(fis);
     Iterator i = c.iterator();
     while (i.hasNext()) {
        Certificate cert = (Certificate)i.next();
        System.out.println(cert);
     }

Since:
  1.2
See Also:
  `Certificate`, `X509Certificate`, `CertPath`, `CRL`, `X509CRL`

Constructor Summary
`protected` | `CertificateFactory(CertificateFactorySpi certFacSpi, Provider provider, String type)` Creates a CertificateFactory object of the given type, and encapsulates the given provider implementation (SPI object) in it.

Method Summary
`Certificate` | `generateCertificate(InputStream inStream)` Generates a certificate object and initializes it with the data read from the input stream `inStream`.
`Collection` | `generateCertificates(InputStream inStream)` Returns a (possibly empty) collection view of the certificates read from the given input stream `inStream`.
`CertPath` | `generateCertPath(InputStream inStream)` Generates a `CertPath` object and initializes it with the data read from the `InputStream` inStream.
`CertPath` | `generateCertPath(InputStream inStream, String encoding)` Generates a `CertPath` object and initializes it with the data read from the `InputStream` inStream.
`CertPath` | `generateCertPath(List certificates)` Generates a `CertPath` object and initializes it with a `List` of `Certificate`s.
`CRL` | `generateCRL(InputStream inStream)` Generates a certificate revocation list (CRL) object and initializes it with the data read from the input stream `inStream`.
`Collection` | `generateCRLs(InputStream inStream)` Returns a (possibly empty) collection view of the CRLs read from the given input stream `inStream`.
`Iterator` | `getCertPathEncodings()` Returns an iteration of the `CertPath` encodings supported by this certificate factory, with the default encoding first.
`static CertificateFactory` | `getInstance(String type)` Generates a certificate factory object that implements the specified certificate type.
`static CertificateFactory` | `getInstance(String type, Provider provider)` Generates a certificate factory object for the specified certificate type from the specified provider.
`static CertificateFactory` | `getInstance(String type, String provider)` Generates a certificate factory object for the specified certificate type from the specified provider.
`Provider` | `getProvider()` Returns the provider of this certificate factory.
`String` | `getType()` Returns the name of the certificate type associated with this certificate factory.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### CertificateFactory

    protected CertificateFactory(CertificateFactorySpi certFacSpi,
                                 Provider provider,
                                 String type)

  Creates a CertificateFactory object of the given type, and encapsulates the given provider implementation (SPI object) in it.

Parameters:
  `certFacSpi` - the provider implementation.
  `provider` - the provider.
  `type` - the certificate type.

Method Detail

### getInstance

    public static final CertificateFactory getInstance(String type)
                                                throws CertificateException

  Generates a certificate factory object that implements the specified certificate type. If the default provider package provides an implementation of the requested certificate type, an instance of certificate factory containing that implementation is returned. If the type is not available in the default package, other packages are searched.

  Parameters:
    `type` - the name of the requested certificate type. See Appendix A in the Java Cryptography Architecture API Specification & Reference for information about standard certificate types.
  Returns:
    a certificate factory object for the specified type.
  Throws:
    `CertificateException` - if the requested certificate type is not available in the default provider package or any of the other provider packages that were searched.

### getInstance

    public static final CertificateFactory getInstance(String type,
                                                       String provider)
                                                throws CertificateException,
                                                       NoSuchProviderException

  Generates a certificate factory object for the specified certificate type from the specified provider.

  Parameters:
    `type` - the certificate type
    `provider` - the name of the provider.
  Returns:
    a certificate factory object for the specified type.
  Throws:
    `CertificateException` - if the certificate type is not available from the specified provider.
    `NoSuchProviderException` - if the provider has not been configured.
  See Also:
    `Provider`

### getInstance

    public static final CertificateFactory getInstance(String type,
                                                       Provider provider)
                                                throws CertificateException

  Generates a certificate factory object for the specified certificate type from the specified provider. Note: the `provider` doesn't have to be registered.

  Parameters:
    `type` - the certificate type
    `provider` - the provider
  Returns:
    a certificate factory object for the specified type.
  Throws:
    `CertificateException` - if the certificate type is not available from the specified provider.
    `IllegalArgumentException` - if the `provider` is null.
  Since:
    1.4
See Also:
  `Provider`

### getProvider

    public final Provider getProvider()

  Returns the provider of this certificate factory.

  Returns:
    the provider of this certificate factory.

### getType

    public final String getType()

  Returns the name of the certificate type associated with this certificate factory.

  Returns:
    the name of the certificate type associated with this certificate factory.

### generateCertificate

    public final Certificate generateCertificate(InputStream inStream)
                                          throws CertificateException

  Generates a certificate object and initializes it with the data read from the input stream `inStream`.

  In order to take advantage of the specialized certificate format supported by this certificate factory, the returned certificate object can be typecast to the corresponding certificate class. For example, if this certificate factory implements X.509 certificates, the returned certificate object can be typecast to the `X509Certificate` class.

  In the case of a certificate factory for X.509 certificates, the certificate provided in `inStream` must be DER-encoded and may be supplied in binary or printable (Base64) encoding. If the certificate is provided in Base64 encoding, it must be bounded at the beginning by -----BEGIN CERTIFICATE-----, and must be bounded at the end by -----END CERTIFICATE-----.

  Note that if the given input stream does not support `mark` and `reset`, this method will consume the entire input stream. Otherwise, each call to this method consumes one certificate and the read position of the input stream is positioned to the next available byte after the inherent end-of-certificate marker. If the data in the input stream does not contain an inherent end-of-certificate marker (other than EOF) and there is trailing data after the certificate is parsed, a `CertificateException` is thrown.

  Parameters:
    `inStream` - an input stream with the certificate data.
  Returns:
    a certificate object initialized with the data from the input stream.
  Throws:
    `CertificateException` - on parsing errors.

### getCertPathEncodings

    public final Iterator getCertPathEncodings()

  Returns an iteration of the `CertPath` encodings supported by this certificate factory, with the default encoding first. See Appendix A in the Java Certification Path API Programmer's Guide for information about standard encoding names and their formats.

  Attempts to modify the returned `Iterator` via its `remove` method result in an `UnsupportedOperationException`.

  Returns:
    an `Iterator` over the names of the supported `CertPath` encodings (as `String`s)
  Since:
    1.4

### generateCertPath

    public final CertPath generateCertPath(InputStream inStream)
                                    throws CertificateException

  Generates a `CertPath` object and initializes it with the data read from the `InputStream` inStream. The data is assumed to be in the default encoding. The name of the default encoding is the first element of the `Iterator` returned by the `getCertPathEncodings` method.

  Parameters:
    `inStream` - an `InputStream` containing the data
  Returns:
    a `CertPath` initialized with the data from the `InputStream`
  Throws:
    `CertificateException` - if an exception occurs while decoding
  Since:
    1.4

### generateCertPath

    public final CertPath generateCertPath(InputStream inStream,
                                           String encoding)
                                    throws CertificateException

  Generates a `CertPath` object and initializes it with the data read from the `InputStream` inStream. The data is assumed to be in the specified encoding. See Appendix A in the Java Certification Path API Programmer's Guide for information about standard encoding names and their formats.

  Parameters:
    `inStream` - an `InputStream` containing the data
    `encoding` - the encoding used for the data
  Returns:
    a `CertPath` initialized with the data from the `InputStream`
  Throws:
    `CertificateException` - if an exception occurs while decoding or the encoding requested is not supported
  Since:
    1.4

### generateCertPath

    public final CertPath generateCertPath(List certificates)
                                    throws CertificateException

  Generates a `CertPath` object and initializes it with a `List` of `Certificate`s.

  The certificates supplied must be of a type supported by the `CertificateFactory`. They will be copied out of the supplied `List` object.

  Parameters:
    `certificates` - a `List` of `Certificate`s
  Returns:
    a `CertPath` initialized with the supplied list of certificates
  Throws:
    `CertificateException` - if an exception occurs
  Since:
    1.4

### generateCertificates

    public final Collection generateCertificates(InputStream inStream)
                                          throws CertificateException

  Returns a (possibly empty) collection view of the certificates read from the given input stream `inStream`.

  In order to take advantage of the specialized certificate format supported by this certificate factory, each element in the returned collection view can be typecast to the corresponding certificate class. For example, if this certificate factory implements X.509 certificates, the elements in the returned collection can be typecast to the `X509Certificate` class.

  In the case of a certificate factory for X.509 certificates, `inStream` may contain a sequence of DER-encoded certificates in the formats described for `generateCertificate`. In addition, `inStream` may contain a PKCS#7 certificate chain. This is a PKCS#7 SignedData object, with the only significant field being certificates. In particular, the signature and the contents are ignored. This format allows multiple certificates to be downloaded at once. If no certificates are present, an empty collection is returned.

  Note that if the given input stream does not support `mark` and `reset`, this method will consume the entire input stream.

  Parameters:
    `inStream` - the input stream with the certificates.
  Returns:
    a (possibly empty) collection view of java.security.cert.Certificate objects initialized with the data from the input stream.
  Throws:
    `CertificateException` - on parsing errors.

### generateCRL

    public final CRL generateCRL(InputStream inStream)
                          throws CRLException

  Generates a certificate revocation list (CRL) object and initializes it with the data read from the input stream `inStream`.

  In order to take advantage of the specialized CRL format supported by this certificate factory, the returned CRL object can be typecast to the corresponding CRL class. For example, if this certificate factory implements X.509 CRLs, the returned CRL object can be typecast to the `X509CRL` class.

  Note that if the given input stream does not support `mark` and `reset`, this method will consume the entire input stream. Otherwise, each call to this method consumes one CRL and the read position of the input stream is positioned to the next available byte after the the inherent end-of-CRL marker. If the data in the input stream does not contain an inherent end-of-CRL marker (other than EOF) and there is trailing data after the CRL is parsed, a `CRLException` is thrown.

  Parameters:
    `inStream` - an input stream with the CRL data.
  Returns:
    a CRL object initialized with the data from the input stream.
  Throws:
    `CRLException` - on parsing errors.

### generateCRLs

    public final Collection generateCRLs(InputStream inStream)
                                  throws CRLException

  Returns a (possibly empty) collection view of the CRLs read from the given input stream `inStream`.

  In order to take advantage of the specialized CRL format supported by this certificate factory, each element in the returned collection view can be typecast to the corresponding CRL class. For example, if this certificate factory implements X.509 CRLs, the elements in the returned collection can be typecast to the `X509CRL` class.

  In the case of a certificate factory for X.509 CRLs, `inStream` may contain a sequence of DER-encoded CRLs. In addition, `inStream` may contain a PKCS#7 CRL set. This is a PKCS#7 SignedData object, with the only significant field being crls. In particular, the signature and the contents are ignored. This format allows multiple CRLs to be downloaded at once. If no CRLs are present, an empty collection is returned.

  Note that if the given input stream does not support `mark` and `reset`, this method will consume the entire input stream.

  Parameters:
    `inStream` - the input stream with the CRLs.
  Returns:
    a (possibly empty) collection view of java.security.cert.CRL objects initialized with the data from the input stream.
  Throws:
    `CRLException` - on parsing errors.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.4.0
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2002 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.